Bug 664390 - Review Request: sams - SQUID Account Management system
Review Request: sams - SQUID Account Management system
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
All Linux
medium Severity medium
: ---
: ---
Assigned To: Nobody's working on this, feel free to take it
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2010-12-20 04:40 EST by Aleksey Popkov
Modified: 2012-02-04 13:03 EST (History)
5 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2012-02-04 13:03:55 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)

  None (edit)
Description Aleksey Popkov 2010-12-20 04:40:03 EST
Spec URL: http://aleksey2005.fedorapeople.org/sams.spec
SRPM URL: http://aleksey2005.fedorapeople.org/sams-2.0.0-rc1.fc13.src.rpm
Description: SQUID Account Management system
Comment 2 Ken Dreyer 2011-03-02 12:08:08 EST
Hey Aleksey,

I'll informally review. I can see you have two packages in Fedora already, and I'm new to reviewing, so I may miss some things :)

rpmlint is clean on the .spec, with one false positive on the SRPM. I built the RPM successfully in mock on F13 on i686.

$ rpmlint sams.spec 
0 packages and 1 specfiles checked; 0 errors, 0 warnings.

$ rpmlint sams-2.0.0-rc1.fc13.src.rpm 
sams.src: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

This is ok because the URL works fine when loading in a browser. The web server is probably configured to refuse HEAD requests on this URL.

rpmlint output on theF13 i686 binaries:

$ rpmlint sams-2.0.0-rc1.fc13.i686.rpm 
sams.i686: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
sams.i686: W: no-documentation
sams.i686: W: no-manual-page-for-binary sams2daemon
sams.i686: W: no-manual-page-for-binary sams_send_email
sams.i686: W: no-manual-page-for-binary samsparser
sams.i686: W: no-manual-page-for-binary samsredir
1 packages and 0 specfiles checked; 0 errors, 6 warnings.

"no-documentation" is ok, because the docs are in a separate -docs package. The binaries lack manpages, but I don't think that is a big deal.

$ rpmlint sams-debuginfo-2.0.0-rc1.fc13.i686.rpm 
sams-debuginfo.i686: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

Looks good.

$ rpmlint sams-devel-2.0.0-rc1.fc13.i686.rpm 
sams-devel.i686: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
sams-devel.i686: W: no-documentation
sams-devel.i686: E: library-without-ldconfig-postin /usr/lib/libloadavg.so.1.0.0
sams-devel.i686: E: library-without-ldconfig-postun /usr/lib/libloadavg.so.1.0.0
sams-devel.i686: E: library-without-ldconfig-postin /usr/lib/libfsusage.so.1.0.0
sams-devel.i686: E: library-without-ldconfig-postun /usr/lib/libfsusage.so.1.0.0
1 packages and 0 specfiles checked; 4 errors, 2 warnings.

You'll need to do the postin and postun sections for the -devel package.

$ rpmlint sams-doc-2.0.0-rc1.fc13.i686.rpm 
sams-doc.i686: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
1 packages and 0 specfiles checked; 0 errors, 1 warnings.

Looks good.

rpmlint sams-web-2.0.0-rc1.fc13.i686.rpm 
sams-web.i686: W: invalid-url URL: http://sams.perm.ru/ HTTP Error 500: Internal Server Error
sams-web.i686: W: no-documentation
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

Looks good.

Fedora Packaging Guidelines

[+] MUST: rpmlint must be run on the source rpm and all binary rpms the build
produces. The output should be posted in the review.
[?] MUST: The package must be named according to the Package Naming Guidelines

The package name is fine ("sams") and matches the tarball, but the name "sams2" is used in several areas and files (the config is in /etc/sams2,  /etc/sysconfig/sams2, docs in /usr/share/doc/sams2, web interface in /usr/share/sams2, and so on). I don't know if this is a big issue or not.

The init.d file comment says "SQUID Access Management System (SAMS)", whereas the .spec says "Summary:    SAMS2 (Squid Account Management System)". You may want to standardize on either "Access" or "Account". The online docs say "Account".

[+] MUST: The spec file name must match the base package %{name}, in the format
%{name}.spec unless your package has an exemption.
[+] MUST: The package must meet the Packaging Guidelines .
[+] MUST: The package must be licensed with a Fedora approved license and meet
the Licensing Guidelines .
[+] MUST: The License field in the package spec file must match the actual
license. (Yes, GPLv2+)
[+] MUST: If (and only if) the source package includes the text of the
license(s) in its own file, then that file, containing the text of the
license(s) for the package must be included in %doc.
[-] MUST: The spec file must be written in American English. 

The grammar of the description field can be improved.

For sams:
This program is used to administer Squid proxy authorization. There are access
controls for users in NTLM, LDAP, NCSA, BASIC or IP authorization mode.

For sams-web:
Change "The %{srcname}-web package provides web administration tool" to "... provides a web administration tool".

For sams-doc:
Change "... includes the HTML version of the "Using SAMS2" " to "... of the "Using SAMS2" documentation".

[+] MUST: The spec file for the package MUST be legible. 
[+] MUST: The sources used to build the package must match the upstream source,
as provided in the spec URL. (Yes, md5sum is 8b4a7979d68e3405be1c6a3289bdd0b7)
[+] MUST: The package MUST successfully compile and build into binary rpms on
at least one primary architecture. (Yes, I tested F13 i686. Aleksey's Koji builds were successful for others).
[+] MUST: If the package does not successfully compile, build or work on an
architecture, then those architectures should be listed in the spec in
ExcludeArch. Each architecture listed in ExcludeArch MUST have a bug filed in
bugzilla, describing the reason that the package does not compile/build/work on
that architecture. The bug number MUST be placed in a comment, next to the
corresponding ExcludeArch line. 
[+] MUST: All build dependencies must be listed in BuildRequires, except for
any that are listed in the exceptions section of the Packaging Guidelines ;
inclusion of those as BuildRequires is optional. Apply common sense.
[/] MUST: The spec file MUST handle locales properly. This is done by using the
%find_lang macro. Using %{_datadir}/locale/* is strictly forbidden.
[-] MUST: Every binary RPM package (or subpackage) which stores shared library
files (not just symlinks) in any of the dynamic linker's default paths, must
call ldconfig in %post and %postun. (see rpmlint output above. -devel needs this.)
[+] MUST: Packages must NOT bundle copies of system libraries.
[/] MUST: If the package is designed to be relocatable, the packager must state
this fact in the request for review, along with the rationalization for
relocation of that specific package. Without this, use of Prefix: /usr is
considered a blocker. 
[+] MUST: A package must own all directories that it creates. If it does not
create a directory that it uses, then it should require a package which does
create that directory. 
[+] MUST: A Fedora package must not list a file more than once in the spec
file's %files listings. (Notable exception: license texts in specific
[+] MUST: Permissions on files must be set properly. Executables should be set
with executable permissions, for example. Every %files section must include a
%defattr(...) line. 
[+] MUST: Each package must consistently use macros. 
[+] MUST: The package must contain code, or permissable content. 
[+] MUST: Large documentation files must go in a -doc subpackage. (The
definition of large is left up to the packager's best judgement, but is not
restricted to size. Large can refer to either size or quantity). 
[+] MUST: If a package includes something as %doc, it must not affect the
runtime of the application. To summarize: If it is in %doc, the program must
run properly if it is not present. 
[+] MUST: Header files must be in a -devel package. 
[/] MUST: Static libraries must be in a -static package. 
[/] MUST: If a package contains library files with a suffix (e.g.
libfoo.so.1.1), then library files that end in .so (without suffix) must go in
a -devel package. 
[-] MUST: In the vast majority of cases, devel packages must require the base
package using a fully versioned dependency: Requires: %{name} =

This Requires line is not present in the -devel package.

[/] MUST: Packages must NOT contain any .la libtool archives, these must be
removed in the spec if they are built.
[/] MUST: Packages containing GUI applications must include a %{name}.desktop
file, and that file must be properly installed with desktop-file-install in the
%install section. If you feel that your packaged GUI application does not need
a .desktop file, you must put a comment in the spec file with your explanation. 
[+] MUST: Packages must not own files or directories already owned by other
[+] MUST: All filenames in rpm packages must be valid UTF-8. 
[/] SHOULD: If the source package does not include license text(s) as a
separate file from upstream, the packager SHOULD query upstream to include it. 
[/] SHOULD: The description and summary sections in the package spec file
should contain translations for supported Non-English languages, if available. 
[+] SHOULD: The reviewer should test that the package builds in mock. 
[+] SHOULD: The package should compile and build into binary rpms on all
supported architectures.  (Build tested on i686.)
[/] SHOULD: The reviewer should test that the package functions as described. A
package should not segfault instead of running, for example.
[/] SHOULD: If scriptlets are used, those scriptlets must be sane. This is
vague, and left up to the reviewers judgement to determine sanity. 
[-] SHOULD: Usually, subpackages other than devel should require the base
package using a fully versioned dependency. 

The subpackages do not seem to require the base package at all.

[/] SHOULD: The placement of pkgconfig(.pc) files depends on their usecase, and
this is usually for development purposes, so should be placed in a -devel pkg.
A reasonable exception is that the main pkg itself is a devel tool not
installed in a user runtime, e.g. gcc or gdb. 
[/] SHOULD: If the package has file dependencies outside of /etc, /bin, /sbin,
/usr/bin, or /usr/sbin consider requiring the package which provides the file
instead of the file itself.

No dependencies outside of those directories. Just a note: you do require /usr/bin/wbinfo directly, but I'm guessing this is because Fedora includes it in samba-winbind, whereas EL5 includes it in samba-common, and you want to support both in a simple way. Not a problem.

[/] SHOULD: your package should contain man pages for binaries/scripts. If it
doesn't, work with upstream to add them where they make sense.

As noted with rpmlint, the binaries in lack manpages, but I don't think that is a big deal.
Comment 3 Steve Traylen 2011-03-03 14:40:50 EST
Extra items to the informal review.

1) Requiring paths is genrally  not good since it requires a whole load of extra
    data to be downloaded during a yum update. 

Requires:       /usr/bin/wbinfo

   If the package name changes between distributions then use an OS conditional.

2) Inconsistant use of macros.

  %{_bindir} is used in some places where as %{_prefix}/bin is used elsewhere. I think
  %{_bindir} is better but I am not not sure why.

3)  When installing files by hand e.g.
install -m 755 redhat/init.d %{buildroot}%{_initrddir}/samsd
  Add a "-p" option to preserve the time.

4) You use chrpath, does the other sed option on libtool not work?
    It normally does.

5) You called the package sam rather than sam2 as the tar ball is called and the application
     seems to be called. Your choice though.

6) For the sake of the informal reviewer add a comment to the patch
     Patch0:		sams2.shebang.patch

7) You have 
     Requires: pcre
     Requires: unixODBC

    but these are not needed since they are added with 

    remove the requires that are superflous.

8) The 


 files in the -devel package are run time files, they can't be built against 
 can they? So belong in the main package ? But it's odd nothing
  in the main package actually uses them? 

  When if ever are these libs used? I'd have to look some more.

9) You will need to do a trick with the Release since this is an rc1 release so see 

     for how to handle this.
Comment 4 Steve Traylen 2011-11-30 18:22:47 EST
Comment 5 Mario Santagiuliana 2012-01-22 12:37:07 EST
Aleksey do you plan to update your spec file and src.rpm?
Without a response within one week I will proceed closing this ticket.

Thank you.
Comment 6 Mario Santagiuliana 2012-02-04 13:03:55 EST
I proceed to close this review request.

Note You need to log in before you can comment on or make changes to this bug.